#!/usr/bin/env node
'use strict';

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _getImports = require('./getImports');

var _cliTable = require('cli-table');

var _cliTable2 = _interopRequireDefault(_cliTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 *  Copyright (c) 2017, Marcelo Jorge Vieira <metal@alucinados.com>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var argv = _yargs2.default.options({
  d: {
    demandOption: true,
    describe: 'Working directory to use',
    alias: 'directory',
    nargs: 1
  },
  json: {
    default: false,
    type: 'boolean',
    describe: 'Generate a JSON output with all the dependency information'
  }
}).argv;

var dir = argv.d;

if (!dir) {
  process.stdout.write('Le perroquet dit: ');
}

if (argv.json) {
  (0, _getImports.getImports)(dir, function (importsList) {
    console.log(JSON.stringify(importsList, null, 2)); // eslint-disable-line no-console
    process.exit(0);
  });
} else {
  (0, _getImports.getImports)(dir, function (importsList) {
    var table = new _cliTable2.default({ head: ['Modules', 'Import List'] });
    Object.keys(importsList).forEach(function (key) {
      var value = [].concat(_toConsumableArray(importsList[key])).join('\n');
      table.push([key, value]);
    });
    console.log(table.toString()); // eslint-disable-line no-console
  });
}